NNG_AIO_ALLOC(3)

NAME
nng_aio_alloc - allocate asynchronous I/O handle

SYNOPSIS

    #include <nng/nng.h>
    int nng_aio_alloc(nng_aio **aiop, void (*callb)(void *), void *arg);

DESCRIPTION

The nng_aio_alloc() function allocates a handle for asynchronous I/O operations, and stores a pointer to it in aiop. The handle is initialized with a completion callback of callb, which will be executed when an associated asynchronous operation finishes. It will be called with the argument arg.

    Note

    The callback callb must not perform any blocking operations, and must complete its execution quickly. If callb does block, this can lead ultimately to an apparent "hang" or deadlock in the application.

Asynchronous I/O operations all take an nng_aio handle such as allocated by this function. Such operations are usually started by a function that returns immediately. The operation is then run asynchronously, and completes sometime later. When that operation is complete, the callback supplied here is called, and that callback is able to determine the result of the operation using nng_aio_result(), nng_aio_count(), and nng_aio_get_output().

It is possible to wait synchronously for an otherwise asynchronous operation by using the function nng_aio_wait(). In that case, it is permissible for callb and arg to both be NULL. Note that if these are NULL, then it will not be possible to determine when the operation is complete except by calling the aforementioned nng_aio_wait().

RETURN VALUES

This function returns 0 on success, and non-zero otherwise.

ERRORS

NNG_ENOMEM
    Insufficient free memory to perform the operation.

SEE ALSO

nng_aio_abort(3), nng_aio_cancel(3), nng_aio_count(3), nng_aio_free(3), nng_aio_get_input(3), nng_aio_get_msg(3), nng_aio_get_output(3), nng_aio_result(3), nng_aio_set_input(3), nng_aio_set_iov(3), nng_aio_set_msg(3), nng_aio_set_timeout(3), nng_aio_stop(3), nng_aio_wait(3), nng_strerror(3), nng_aio(5), nng(7)